/*
 * VIII Wiosenny Turniej w Programowaniu Zespolowym
 * Politechnika Poznanska, 29.05.2004
 *
 * Rozwiazanie pomocnicze do zadania H - Taxi
 * Zlozonosc: O(N^2)
 * (algorytm nieoptymalny, ale na pewno dobry)
 * 
 * Autor programu: Bartosz Nowierski
 */

#include <stdio.h>
#define NDEBUG
#include <assert.h>


#define MAXN 40000
#define MAXV 1000000

#define abs(a) (((a) < 0) ? (-(a)) : (a))


int X[MAXN], Y[MAXN];


int main()
{
  int D;
  int N;
  int i, j;
  int max, dist;


  if (scanf("%d", &D) < 1)
    assert(0);
  assert((D > 0) && (D <= 50));

  while (D--)
  {
    if (scanf("%d", &N) < 1)
      assert(0);
    assert((N >= 2) && (N <= MAXN));

    for (i = 0; i < N; i++)
    {
      if (scanf("%d%d", &X[i], &Y[i]) < 2)
        assert(0);
      assert((X[i] >= 0) && (X[i] <= MAXV));
      assert((Y[i] >= 0) && (Y[i] <= MAXV));
    }
    max = -1;
    for (i = 0; i < N; i++)
    {
      for (j = 0; j < N; j++)
      {
        dist = abs(X[i]-X[j])+abs(Y[i]-Y[j]);
        if (dist > max)
          max = dist;
      }
    }
    assert((max >= 0) && (max <= 2*MAXV));
    printf("%d\n", max);
    fflush(stdout);
  }

  return 0;
}
